# Copyright (c) 2014, 2015  Dave Love, University of Liverpool
# Licence as for the package itself

%if 0%{?el6}
%ifarch ppc64
%bcond_with mpich
%else
%bcond_without mpich
%endif
%else
%bcond_without mpich
%endif

Name:		gti
Version:	1.5.0
Release:	1%{?dist}
Summary:	Generic Tool Infrastructure for parallel programs
License:	BSD
URL:		https://doc.itc.rwth-aachen.de/display/CCP/Project+MUST
Source0:	https://doc.itc.rwth-aachen.de/download/attachments/7373495/gti-for-must-1.5.tgz
Patch1:		gti-mpi3.patch
BuildRequires:	cmake gcc-c++ libxml2-devel pnmpi-openmpi-devel python
%if %{with mpich}
BuildRequires:	pnmpi-mpich-devel
%endif

%global desc \
GTI is an infrastructure for tools that operate in parallel systems. It\
provides a simple means of specifying and implementing a tool without\
the need to develop extensive infrastructure.

%description
%desc

%package openmpi
Summary:	Generic Tool Infrastructure for parallel programs - openmpi
Requires:	pnmpi-openmpi%{?_isa} = %version
Obsoletes:      %name < 1.5

%description openmpi
%desc

This is the openmpi version.

%package openmpi-devel
Summary:        Development files for %name
Requires:	%name-openmpi%{?_isa} = %version-%release
Requires:	pnmpi-openmpi-devel%{?_isa} = %version
Obsoletes:      %name-devel < 1.5

%description openmpi-devel
Development files for %name.

%if %{with mpich}
%package mpich
Summary:	Generic Tool Infrastructure for parallel programs - mpich
Requires:	pnmpi-mpich%{?_isa} = %version

%description mpich
%desc

This is the mpich version.

%package mpich-devel
Summary:        Development files for %name
Requires:	%name-mpich%{?_isa} = %version-%release
Requires:	pnmpi-mpich-devel%{?_isa} = %version

%description mpich-devel
Development files for %name.
%endif

%prep
%setup -q -n gti-for-must-1.5
mkdir openmpi mpich


%build

%global do_build \
export CXXFLAGS="-I$MPI_INCLUDE/pnmpi %optflags -std=gnu++98" \
%cmake -DPnMPI_INSTALL_PREFIX=$MPI_HOME -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=$MPI_LIB/gti -DGTI_ENABLE_FORTRAN=yes -DENABLE_TESTS=yes .. \
make %{?_smp_mflags}

%_openmpi_load
pushd openmpi
%do_build
popd
%_openmpi_unload

%if %{with mpich}
%_mpich_load
pushd mpich
%do_build
popd
%_mpich_unload
%endif

%check
# ctest -V


%install
make -C openmpi install DESTDIR=$RPM_BUILD_ROOT
%if %{with mpich}
make -C mpich install DESTDIR=$RPM_BUILD_ROOT
%endif
chmod 0755 $RPM_BUILD_ROOT%_libdir/*/lib/%name/bin/* $RPM_BUILD_ROOT%_libdir/*/lib/%name/modules/libgtiRecordGenImpl.so


%{!?_licensedir:%global license %doc}
%files openmpi
%doc README.txt
%license LICENSE.txt
%_libdir/openmpi/lib/%name/bin
%_libdir/openmpi/lib/%name/modules
%_libdir/openmpi/lib/%name/specifications

%files openmpi-devel
%_libdir/openmpi/lib/%name/cmakemodules
%_libdir/openmpi/lib/%name/include
%_libdir/openmpi/lib/%name/src

%if %{with mpich}
%files mpich
%doc README.txt
%license LICENSE.txt
%_libdir/mpich/lib/%name/bin
%_libdir/mpich/lib/%name/modules
%_libdir/mpich/lib/%name/specifications

%files mpich-devel
%_libdir/mpich/lib/%name/cmakemodules
%_libdir/mpich/lib/%name/include
%_libdir/mpich/lib/%name/src
%endif


%changelog
* Mon Jul 25 2016 Dave Love <loveshack@fedoraproject.org> - 1.5.0-1
- New version

* Fri May 13 2016 Dave Love <loveshack@fedoraproject.org> - 1.5.0-0.3.rc1
- Obsolete old gti

* Sat May  7 2016 Dave Love <loveshack@fedoraproject.org> - 1.5.0-0.2.rc1
- Require python
- Compile with -std=gnu++98

* Thu May  5 2016 Dave Love <loveshack@fedoraproject.org> - 1.5.0-0.1.rc1
- New version
- Depend on versioned pnmpi
- Use %%license
- Remove el5-isms

* Wed May 20 2015 Dave Love <d.love@liverpool.ac.uk> - 1.4.0-3
- Non-rc version

* Sat Mar 21 2015 Dave Love <d.love@liverpool.ac.uk> - 1.4.0-2
- Fix requires
- Add mpich
- Fix MPI3 declarations

* Fri Dec  5 2014 Dave Love <d.love@liverpool.ac.uk> - 1.4.0-1
- New version

* Sat Nov  1 2014 Dave Love <d.love@liverpool.ac.uk> - 1.3.0-2
- Install in MPI_HOME

* Tue Jul 29 2014 Dave Love <d.love@liverpool.ac.uk> - 1.3.0-1
- New version
- Drop patches

* Mon Jul 28 2014 Dave Love <d.love@liverpool.ac.uk> - 1.2.0-2
- Adjust for current pnmpi packaging

* Wed Dec  4 2013 Dave Love <d.love@liverpool.ac.uk> - 1.2.0-1
- Initial packaging
